<?php
/**
 * @package JS Calendar Event for Joomla! 1.5
 * @version $Id: components/com_jscalendar/models/jscalendar.php 1.5.7 2010-10-20 19:16:53 $
 * @author JoomlaSeller.com
 * @copyright (C) 2010- JoomlaSeller.com
 *
 * JoomlaSeller Calendar Event is a free software. You may make changes but
 * you may not sell it
 *
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 *
 * jscalendar model for JS Calendar Event component
 * @email webmaster@joomlaseller.com
 *
 */
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

//remove notice msg from lay_out
ini_set('error_reporting',E_ALL ^ E_NOTICE); 

jimport( 'joomla.application.component.model' );

/**
 * JS Calendar Model
 *
 */
class JsCalendarModelJsCalendar extends JModel  
{ 
	//generate current date and prev month and next month date format
	function getdates(){ 
	
		global $mainframe;
		$db 			=& JFactory::getDBO(); 	
		$days_photo		= array();
		$layout	= JRequest::getVar( 'layout', 'default');
	
		if($layout == 'default'){
			$ss_month		= isset($_REQUEST['month']) && $_REQUEST['month'] != '' ? intval($_REQUEST['month']) : intval(date('n'));//JRequest::getVar( 'month', date('n') );	
			$ss_year		= isset($_REQUEST['year'])  && $_REQUEST['year']  != '' ? intval($_REQUEST['year'])  : intval(date('Y'));//JRequest::getVar( 'year', date('Y') );		
			
			//extra verification for XSS
			if(is_int($ss_month) && $ss_month < 13 && $ss_month > 0){
			}else{
				$ss_month = date('n');
			}
			if(is_int($ss_year) && strlen($ss_year) == 4 ){
			}else{
				$ss_year = date('Y');
			}
			
			$ss_daynum 		= cal_days_in_month(CAL_GREGORIAN, $ss_month, $ss_year); 
			$prevmonth 		= date("n", mktime(0, 0, 0, $ss_month-1, date("d"), $ss_year));
			$prevmonth_year = date("Y", mktime(0, 0, 0, $ss_month-1, date("d"), $ss_year));		
			$nextmonth 		= date("n", mktime(0, 0, 0, $ss_month+1, date("d"), $ss_year)); 
			$nextmonth_year = date("Y", mktime(0, 0, 0, $ss_month+1, date("d"), $ss_year));		
			$return = array("prevmonth"=>$prevmonth,"prevmonth_year"=>$prevmonth_year,"nextmonth"=>$nextmonth,"nextmonth_year"=>$nextmonth_year,"ss_daynum"=>$ss_daynum);
		}elseif($layout == 'day'){
			$ss_month		= isset($_REQUEST['month']) && $_REQUEST['month'] != '' ? intval($_REQUEST['month']) : intval(date('n'));//JRequest::getVar( 'month', date('n') );	
			$ss_day			= isset($_REQUEST['day'])  && $_REQUEST['day']  != '' ? intval($_REQUEST['day'])  : intval(date('d'));//JRequest::getVar( 'year', date('Y') );		
			$ss_year		= isset($_REQUEST['year'])  && $_REQUEST['year']  != '' ? intval($_REQUEST['year'])  : intval(date('Y'));//JRequest::getVar( 'year', date('Y') );
			
			//extra verification for XSS
			if(is_int($ss_month) && $ss_month < 13 && $ss_month > 0){
			}else{
				$ss_month = date('n');
			}
			if(is_int($ss_year) && strlen($ss_year) == 4 ){
			}else{
				$ss_year = date('Y');
			}
			if(is_int($ss_day) && $ss_day > 0 && $ss_day < 32){
			}else{
				$ss_day = date('d');
			}			
			
			//$ss_daynum 		= cal_days_in_month(CAL_GREGORIAN, $ss_month, $ss_year); 
			$prevmonth 		= date("n", mktime(0, 0, 0, $ss_month, $ss_day-1, $ss_year));
			$prevmonth_day 	= date("d", mktime(0, 0, 0, $ss_month, $ss_day-1, $ss_year));		
			$nextmonth 		= date("n", mktime(0, 0, 0, $ss_month, $ss_day+1, $ss_year)); 
			$nextmonth_day 	= date("d", mktime(0, 0, 0, $ss_month, $ss_day+1, $ss_year));
			$prevyear		= date("Y", mktime(0, 0, 0, $ss_month, $ss_day-1, $ss_year));
			$nextyear		= date("Y", mktime(0, 0, 0, $ss_month, $ss_day+1, $ss_year));
			$return = array("prevmonth"=>$prevmonth,"prevmonth_day"=>$prevmonth_day,"nextmonth"=>$nextmonth,"nextmonth_day"=>$nextmonth_day,"prevyear"=>$prevyear,"nextyear"=>$nextyear);
		}elseif($layout == 'week'){
			$ss_month		= isset($_REQUEST['month']) && $_REQUEST['month'] != '' ? intval($_REQUEST['month']) : intval(date('n'));//JRequest::getVar( 'month', date('n') );	
			$ss_day			= isset($_REQUEST['day'])  && $_REQUEST['day']  != '' ? intval($_REQUEST['day'])  : intval(date('d'));//JRequest::getVar( 'year', date('Y') );		
			$ss_year		= isset($_REQUEST['year'])  && $_REQUEST['year']  != '' ? intval($_REQUEST['year'])  : intval(date('Y'));//JRequest::getVar( 'year', date('Y') );	

			//extra verification for XSS
			if(is_int($ss_month) && $ss_month < 13 && $ss_month > 0){
			}else{
				$ss_month = date('n');
			}
			if(is_int($ss_year) && strlen($ss_year) == 4 ){
			}else{
				$ss_year = date('Y');
			}
			if(is_int($ss_day) && $ss_day > 0 && $ss_day < 32){
			}else{
				$ss_day = date('d');
			}			
							
			$week_dates 	= JsCalendarModelJsCalendar::week_from_monday($ss_day."-".$ss_month."-".$ss_year);
			$prevmonth 		= date("n", mktime(0, 0, 0, $ss_month, $ss_day-7, $ss_year));
			$prevmonth_day 	= date("d", mktime(0, 0, 0, $ss_month, $ss_day-7, $ss_year));		
			$prevyear		= date("Y", mktime(0, 0, 0, $ss_month, $ss_day-7, $ss_year));			
			$nextmonth 		= date("n", mktime(0, 0, 0, $ss_month, $ss_day+7, $ss_year)); 
			$nextmonth_day 	= date("d", mktime(0, 0, 0, $ss_month, $ss_day+7, $ss_year));
			$nextyear		= date("Y", mktime(0, 0, 0, $ss_month, $ss_day+7, $ss_year));
			$return = array("prevmonth"=>$prevmonth,"prevmonth_day"=>$prevmonth_day,"nextmonth"=>$nextmonth,"nextmonth_day"=>$nextmonth_day,"prevyear"=>$prevyear,"nextyear"=>$nextyear,"week_dates"=>$week_dates);
		}else{
			$return = "";
		}
		return $return;
	}
	
	//get the jobs for the logged in user
	function getmy_jobs(){
		global $mainframe;
		$db 			=& JFactory::getDBO(); 	
		$days_job		= array();		
		$my 			= & JFactory::getUser();
		$myEscaped  	= $my->id;
		$layout	= JRequest::getVar( 'layout', 'default');

		if($layout == 'default'){
			$ss_month		= isset($_REQUEST['month']) && $_REQUEST['month'] != '' ? intval($_REQUEST['month']) : intval(date('n'));//JRequest::getVar( 'month', date('n') );	
			$ss_year		= isset($_REQUEST['year'])  && $_REQUEST['year']  != '' ? intval($_REQUEST['year'])  : intval(date('Y'));//JRequest::getVar( 'year', date('Y') );		
			
			//extra verification for XSS
			if(is_int($ss_month) && $ss_month < 13 && $ss_month > 0){
			}else{
				$ss_month = date('n');
			}
			if(is_int($ss_year) && strlen($ss_year) == 4 ){
			}else{
				$ss_year = date('Y');
			}
	
			//get current month days number
			//$ss_daynum 		= cal_days_in_month(CAL_GREGORIAN, date('n'), date('Y')); 
			$ss_daynum 		= cal_days_in_month(CAL_GREGORIAN, $ss_month, $ss_year); 		
	
			//get each day photo from database
			for( $i = 1; $i <= $ss_daynum; $i++ ){
				//unset($photo);
				//$week		= JobCallendarHelpers::get_week_range($i,$ss_month,$ss_year);
	
				$where 		= array();
				$where[] 	= ' created = "'.$ss_year.'-'.$ss_month.'-'.$i.'"';
				$where[] 	= ' published = 1 ';

				$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );

				$orderby = ' ORDER BY ordering ASC ';
				$query = 'SELECT * ' 
						.' FROM #__jscalendar_jobs '
						.$where
						.$orderby;
				$db->setQuery($query);
				$job = $db->loadObjectList();
				// Make sure there aren't any errors
				if ($db->getErrorNum()) {
					echo $db->getErrorMsg();
					exit;
				}
	
				if(isset($job[0])){
					//assign this photo to the photos array
					$days_job[$i] = $job;
				}
			}		
		}elseif($layout == 'day'){
			$ss_month	= isset($_REQUEST['month']) && $_REQUEST['month'] != '' ? intval($_REQUEST['month']) : intval(date('n'));//JRequest::getVar( 'month', date('n') );	
			$ss_day		= isset($_REQUEST['day'])  && $_REQUEST['day']  != '' ? intval($_REQUEST['day'])  : intval(date('d'));//JRequest::getVar( 'year', date('Y') );		
			$ss_year	= isset($_REQUEST['year'])  && $_REQUEST['year']  != '' ? intval($_REQUEST['year'])  : intval(date('Y'));//JRequest::getVar( 'year', date('Y') );					
			
			//extra verification for XSS
			if(is_int($ss_month) && $ss_month < 13 && $ss_month > 0){
			}else{
				$ss_month = date('n');
			}
			if(is_int($ss_year) && strlen($ss_year) == 4 ){
			}else{
				$ss_year = date('Y');
			}
			if(is_int($ss_day) && $ss_day > 0 && $ss_day < 32){
			}else{
				$ss_day = date('d');
			}
			
			$where 		= array();
			//$where[] 	= ' archive = "0" ';
			$where[] 	= ' created = "'.$ss_year.'-'.$ss_month.'-'.$ss_day.'"';
			$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );

			$orderby = ' ORDER BY ordering ASC ';
			$query = 'SELECT * ' 
					.' FROM #__jscalendar_jobs '
					.$where
					.$orderby;
			$db->setQuery($query);
			$job = $db->loadObjectList();
			// Make sure there aren't any errors
			if ($db->getErrorNum()) {
				echo $db->getErrorMsg();
				exit;
			}
			if(isset($job[0])){
				//assign this photo to the photos array
				$days_job = $job;
			}
		}elseif($layout == 'week'){
			$ss_month	= isset($_REQUEST['month']) && $_REQUEST['month'] != '' ? intval($_REQUEST['month']) : intval(date('m'));//JRequest::getVar( 'month', date('n') );	
			$ss_day		= isset($_REQUEST['day'])  && $_REQUEST['day']  != '' ? intval($_REQUEST['day'])  : intval(date('d'));//JRequest::getVar( 'year', date('Y') );		
			$ss_year	= isset($_REQUEST['year'])  && $_REQUEST['year']  != '' ? intval($_REQUEST['year'])  : intval(date('Y'));//JRequest::getVar( 'year', date('Y') );					
			
			//extra verification for XSS
			if(is_int($ss_month) && $ss_month < 13 && $ss_month > 0){
			}else{
				$ss_month = date('n');
			}
			if(is_int($ss_year) && strlen($ss_year) == 4 ){
			}else{
				$ss_year = date('Y');
			}
			if(is_int($ss_day) && $ss_day > 0 && $ss_day < 32){
			}else{
				$ss_day = date('d');
			}			
			
			$week_number = 	date("W", mktime(0, 0, 0, $ss_month, $ss_day, $ss_year));
			$week_dates = JsCalendarModelJsCalendar::week_from_monday($ss_day."-".$ss_month."-".$ss_year);//date('Y-m-d', strtotime($ss_year."W".$week_number.'1'));

			$where 		= array();
			$where[] 	= ' created = "'.$ss_year.'-'.$ss_month.'-'.$ss_day.'"';			
			$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
			
			$orderby = ' ORDER BY ordering ASC ';
			$query = 'SELECT * ' 
					.' FROM #__jscalendar_jobs '
					.$where
					.$orderby;
			$db->setQuery($query);
			$job = $db->loadObjectList();
			// Make sure there aren't any errors
			if ($db->getErrorNum()) {
				echo $db->getErrorMsg();
				exit;
			}
			if(isset($job[0])){
				for($j=0;$j<=6;$j++){
					foreach($job as $job_row => $job_value){
					//assign to all days of the week
						if($job_value->created <= $week_dates[$j] && $job_value->ended >= $week_dates[$j]){
							//assign this photo to the photos array
							$days_job[$week_dates[$j]][] = $job_value;
						}
					}
				}
			}
		}
		return $days_job;
	}

	function week_from_monday($date) {
		// Assuming $date is in format DD-MM-YYYY
		list($day, $month, $year) = explode("-", $date);
	
		// Get the weekday of the given date
		$wkday = date('l',mktime('0','0','0', $month, $day, $year));

		switch($wkday) {
			case 'Monday': $numDaysToMon = 0; break;
			case 'Tuesday': $numDaysToMon = 1; break;
			case 'Wednesday': $numDaysToMon = 2; break;
			case 'Thursday': $numDaysToMon = 3; break;
			case 'Friday': $numDaysToMon = 4; break;
			case 'Saturday': $numDaysToMon = 5; break;
			case 'Sunday': $numDaysToMon = 6; break;   
		}
	
		// Timestamp of the monday for that week
		$monday = mktime('0','0','0', $month, $day-$numDaysToMon, $year);
	
		$seconds_in_a_day = 86400;
	
		// Get date for 7 days from Monday (inclusive)
		for($i=0; $i<7; $i++)
		{
			$dates[$i] = date('Y-m-d',$monday+($seconds_in_a_day*$i));
		}
	
		return $dates;
	}

	//get the jobs for the logged in user
	function getjob(){

		global $mainframe;
		$db 			=& JFactory::getDBO(); 	
		$day			= isset($_REQUEST['day']) && $_REQUEST['day'] != '' ? $_REQUEST['day'] : date("Y").'-'.date("m").'-'.date("d");//JRequest::getVar( 'day', date("Y").'-'.date("m").'-'.date("d"));//
		$ev_id			= JRequest::getInt( 'ev_id', 0);
		$my 			= & JFactory::getUser();

		$pattern = '/^[0-9]{4}-[0-9]{2}-[0-9]{2}/';
		$day = str_replace("_","-",$day);
		preg_match($pattern, $day, $matches, PREG_OFFSET_CAPTURE);

		//   && is_int($ev_id)
		//get each day photo from database
		if($day != '' && $ev_id > 0 && !empty($matches[0][0])){// && $my->id > 0
			//unset($photo);
			//$week		= JobCallendarHelpers::get_week_range($i,$ss_month,$ss_year);

			$where 		= array();
			//$where[] 	= ' archive = "0" ';
			$where[] 	= ' created = "'.$day.'"';
			$myEscaped  = $my->id;
			//$myEscaped = $db->Quote( $db->getEscaped( $my->id, true ), false );
			//if($my->usertype == 'Super Administrator' || $my->usertype == 'Administrator'){
			//}else{
			//	$where[] 	= ' users LIKE "'.$myEscaped.'" OR users LIKE "'.$myEscaped.',%" OR users LIKE "%,'.$myEscaped.'" OR users LIKE "%,'.$myEscaped.',%"';
			//}
			
			if($ev_id > 0){
				$where[] 	= ' id = '.intval($ev_id);
			}

			//$where[] 	= ' ("'.$week['first'].'" <= publish <= "'.$week['last'].'")';
			//$where[] 	= ' publish BETWEEN "'.$week['first'].'" and "'.$week['last'].'"';
			$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );

			//$orderby = ' ORDER BY votes DESC ';
			$query = 'SELECT * ' 
					.' FROM #__jscalendar_jobs '
					.$where;
					//.$orderby;
			$db->setQuery($query);
			$job = $db->loadObjectList();
			// Make sure there aren't any errors
			if ($db->getErrorNum()) {
				echo $db->getErrorMsg();
				exit;
			}

			if(isset($job[0])){
				//assign this photo to the photos array
				return $job;
			}else{
				return array();
			}
		}		
	}
	
	//generate a list with all JS Calendar settings
	function getjscalendar_settings(){
		global $mainframe;
		$id	= JRequest::getVar( 'id', '', '', 'int' );
		$db =& JFactory::getDBO();

		//get all settings
		$sql = "select * from #__jscalendar_settings";
		$db->setQuery($sql, 0, 1);
		//generate error msg		 
		if ($db->getErrorNum()) {
			echo $db->stderr();
			exit;
		}		
		//$categories = $db->loadAssocList();
		$settings = $db->loadObjectList();		
		return $settings;
	}	
}
?>